## khronos-opencl-clhpp 3.0~2023.02.06

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(OpenCLHeadersCpp
  VERSION 3.0
  LANGUAGES CXX # Ideally should be NONE, but GNUInstallDirs detects platform arch using try_compile
  # https://stackoverflow.com/questions/43379311/why-does-project-affect-cmakes-opinion-on-cmake-sizeof-void-p
)
enable_testing()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(BUILD_DOCS "Build Documentation" ON)
option(BUILD_EXAMPLES "Build Examples" ON)
option(OPENCL_CLHPP_BUILD_TESTING "Enable support for OpenCL C++ headers testing." OFF)
set(THREADS_PREFER_PTHREAD_FLAG ON CACHE BOOL
  "find_package(Threads) preference. Recommendation is to keep default value."
)
# Legacy helper variables, see later at finding headers and ICD Loader
set(OPENCL_DIST_DIR "" CACHE PATH "OpenCL source dir (legacy helper var)")
set(OPENCL_LIB_DIR "${OPENCL_DIST_DIR}/lib" CACHE PATH "OpenCL library dir (legacy helper var)" )
set(OPENCL_INCLUDE_DIR "${OPENCL_DIST_DIR}/include" CACHE PATH "OpenCL source dir (legacy helper var)")
# Helper vars with names consistent with OpenCL-ICD-Loader's OPENCL_ICD_LOADER_HEADERS_DIR
# Default values taken from legacy defaults
set(OPENCL_CLHPP_HEADERS_DIR "${OPENCL_INCLUDE_DIR}" CACHE PATH "OpenCL headers dir")
set(OPENCL_CLHPP_LOADER_DIR "${OPENCL_LIB_DIR}" CACHE PATH "OpenCL library dir")

add_library(HeadersCpp INTERFACE)
add_library(OpenCL::HeadersCpp ALIAS HeadersCpp)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME OR OPENCL_CLHPP_BUILD_TESTING)
  include(CTest)
endif()
if((CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME OR OPENCL_CLHPP_BUILD_TESTING) AND BUILD_TESTING)
  set(CLHPP_BUILD_TESTS ON)
endif()

# In the spirit of backward compatibility, to not break existing build automation
# we first check if the helper vars refer to existing files. If yes, use them.
# Otherwise search using 3.0 installed CMake Package Configs.
if(EXISTS "${OPENCL_CLHPP_HEADERS_DIR}/CL/cl.h")
  if(NOT TARGET OpenCL::Headers)
    message(STATUS "Defining OpenCL::Headers through OPENCL_INCLUDE_DIR")
    add_library(OpenCLHeaders INTERFACE)
    add_library(OpenCL::Headers ALIAS OpenCLHeaders)
    target_include_directories(OpenCLHeaders INTERFACE ${OPENCL_INCLUDE_DIR})
  endif()
else()
  if(NOT TARGET OpenCL::Headers)
    find_package(OpenCLHeaders REQUIRED)
  endif()
endif()
if(BUILD_EXAMPLES OR CLHPP_BUILD_TESTS)
  enable_language(C)
  find_package(Threads REQUIRED)
endif()
if(CLHPP_BUILD_TESTS)
  find_program(RUBY_EXECUTABLE ruby REQUIRED)
endif()

target_include_directories(HeadersCpp
  INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)
target_link_libraries(HeadersCpp
  INTERFACE
    OpenCL::Headers
)

install(
  TARGETS HeadersCpp
  EXPORT OpenCLHeadersCppTargets
)

include(GNUInstallDirs)

install(
  DIRECTORY include/CL
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
export(
  EXPORT OpenCLHeadersCppTargets
  FILE ${PROJECT_BINARY_DIR}/OpenCLHeadersCpp/OpenCLHeadersCppTargets.cmake
  NAMESPACE OpenCL::
)
file(
  WRITE ${PROJECT_BINARY_DIR}/OpenCLHeadersCpp/OpenCLHeadersCppConfig.cmake
  "include(\"\${CMAKE_CURRENT_LIST_DIR}/OpenCLHeadersCppTargets.cmake\")"
)

set(config_package_location ${CMAKE_INSTALL_DATADIR}/cmake/OpenCLHeadersCpp)
install(
  EXPORT OpenCLHeadersCppTargets
  FILE OpenCLHeadersCppTargets.cmake
  NAMESPACE OpenCL::
  DESTINATION ${config_package_location}
)
install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenCLHeadersCpp/OpenCLHeadersCppConfig.cmake
  DESTINATION ${config_package_location}
)

unset(CMAKE_SIZEOF_VOID_P)
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/OpenCLHeadersCpp/OpenCLHeadersCppConfigVersion.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion
)
install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenCLHeadersCpp/OpenCLHeadersCppConfigVersion.cmake
  DESTINATION ${config_package_location}
)

set(UNITY_DIR ${PROJECT_SOURCE_DIR}/external/Unity CACHE PATH "Unity dir")
set(CMOCK_DIR ${PROJECT_SOURCE_DIR}/external/CMock CACHE PATH "CMock dir")

if(BUILD_DOCS)
  add_subdirectory(docs)
endif(BUILD_DOCS)

if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif(BUILD_EXAMPLES)

if(CLHPP_BUILD_TESTS)
  add_subdirectory(tests)
endif(CLHPP_BUILD_TESTS)

=== docs/CMakeLists.txt ===
find_package(Doxygen)

if (DOXYGEN_FOUND)

configure_file(Doxyfile.in Doxyfile)
add_custom_target(
  docs
  COMMAND
  ${DOXYGEN_EXECUTABLE}
  WORKING_DIRECTORY
  ${CMAKE_CURRENT_BINARY_DIR}
  VERBATIM)

endif (DOXYGEN_FOUND)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

add_subdirectory(src)

=== test/Makefile ===
CC = gcc
ifeq ($(shell uname -s), Darwin)
CC = clang
endif
ifeq ($(findstring clang, $(CC)), clang)
E = -Weverything
CFLAGS += $E -Wno-unknown-warning-option -Wno-missing-prototypes
CFLAGS += -Wno-unused-macros -Wno-padded -Wno-missing-noreturn
endif
CFLAGS += -std=c99 -pedantic -Wall -Wextra -Wconversion -Werror
CFLAGS += -Wno-switch-enum -Wno-double-promotion
CFLAGS += -Wbad-function-cast -Wcast-qual -Wold-style-definition -Wshadow -Wstrict-overflow \
          -Wstrict-prototypes -Wswitch-default -Wundef
#DEBUG = -O0 -g
CFLAGS += $(DEBUG)
DEFINES =  -D UNITY_OUTPUT_CHAR=putcharSpy
DEFINES += -D UNITY_OUTPUT_CHAR_HEADER_DECLARATION=putcharSpy\(int\)
DEFINES += -D UNITY_OUTPUT_FLUSH=flushSpy
DEFINES += -D UNITY_OUTPUT_FLUSH_HEADER_DECLARATION=flushSpy\(void\)
DEFINES += $(UNITY_SUPPORT_64) $(UNITY_INCLUDE_DOUBLE)
UNITY_SUPPORT_64 = -D UNITY_SUPPORT_64
UNITY_INCLUDE_DOUBLE = -D UNITY_INCLUDE_DOUBLE
SRC = ../src/unity.c tests/testunity.c build/testunityRunner.c
INC_DIR = -I ../src
COV_FLAGS = -fprofile-arcs -ftest-coverage -I ../../src
BUILD_DIR = build
TARGET = build/testunity-cov.exe

# To generate coverage, call 'make -s', the default target runs.
# For verbose output of all the tests, run 'make test'.
default: coverage
.PHONY: default coverage test clean
coverage: DEFINES += -D UNITY_NO_WEAK
coverage: $(BUILD_DIR)/testunityRunner.c
	cd $(BUILD_DIR) && \
	$(CC) $(CFLAGS) $(DEFINES) $(foreach i,$(SRC), ../$i) $(COV_FLAGS) -o ../$(TARGET)
	rm -f $(BUILD_DIR)/*.gcda
	./$(TARGET) | grep 'Tests\|]]]' -A1
	cd $(BUILD_DIR) && \
	gcov unity.c | head -3
	grep '###' $(BUILD_DIR)/unity.c.gcov -C2 || true

test: $(BUILD_DIR)/testunityRunner.c
	$(CC) $(CFLAGS) $(DEFINES) $(INC_DIR) $(SRC) -o $(TARGET)
	./$(TARGET)

# Compile only, for testing that preprocessor detection works
UNITY_C_ONLY =-c ../src/unity.c -o $(BUILD_DIR)/unity.o
intDetection:
	$(CC) $(CFLAGS) $(INC_DIR) $(UNITY_C_ONLY) -D UNITY_EXCLUDE_STDINT_H
	$(CC) $(CFLAGS) $(INC_DIR) $(UNITY_C_ONLY) -D UNITY_EXCLUDE_LIMITS_H

$(BUILD_DIR)/testunityRunner.c: tests/testunity.c | $(BUILD_DIR)
	awk $(AWK_SCRIPT) tests/testunity.c > $@

AWK_SCRIPT=\
  '/^void test/{ declarations[d++]=$$0; gsub(/\(?void\)? ?/,""); tests[t++]=$$0; line[u++]=NR } \
  END{ print "\#include \"unity.h\" /* Autogenerated by awk in Makefile */" ;                   \
       for (i=0; i<d; i++) { print declarations[i] ";" }                                        \
       print "int main(void)\n{\n    UnityBegin(\"" FILENAME "\");" ;                           \
       for (i=0; i<t; i++) { print "    RUN_TEST(" tests[i] ", " line[i] ");" }                 \
       print "    return UNITY_END();\n}" }'

$(BUILD_DIR):
	mkdir -p $(BUILD_DIR)

clean:
	rm -f $(TARGET) $(BUILD_DIR)/*.gc* $(BUILD_DIR)/testunityRunner.c

=== tests/CMakeLists.txt ===
set(OPENCL_HEADERS_INCLUDE_DIR_GENEXPR $<TARGET_PROPERTY:OpenCL::Headers,INTERFACE_INCLUDE_DIRECTORIES>)
###############################
###                         ###
### Workaround to CMake bug ###
###                         ###
###############################
#
# The generated mocks\Mockcl.h include the OpenCL headers as
#
# #include "CL/cl_platform.h"
# #include "cl.h"
#
# which requires the tests to not only inherit the INTERFACE_INCLUDE_DIRECTORIES, but also the same dir with
# /CL appended at the end. There seems to be a bug in CMake (3.19 even) where if a target has the same genexpr
# predicate twice, the second time it always fails. Having both
#
# $<TARGET_PROPERTY:Headers,INTERFACE_INCLUDE_DIRECTORIES> (invisbly via linking to OpenCL::Headers)
# $<TARGET_PROPERTY:Headers,INTERFACE_INCLUDE_DIRECTORIES>/CL
#
# means we can only get one of these switches. We forcibly go around it by extracting the value manually.
#
# Bug ticket: https://gitlab.kitware.com/cmake/cmake/-/issues/22735
#
# ticket closed with by-design. We should find a way to fix the Mock tests to not consume the public API using
# mixed style includes.
get_target_property(OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES OpenCL::Headers INTERFACE_INCLUDE_DIRECTORIES)

if(OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES MATCHES "BUILD_INTERFACE")
  # When building OpenCL::Headers is part of this build (OpenCL-SDK), we have a property like for eg.
  # $<BUILD_INTERFACE:C:/OpenCL-SDK/external/OpenCL-Headers>;$<INSTALL_INTERFACE:include>
  # and need to touch up this property. We want the BUILD_INTERFACE part only.
  # When OpenCL::Headers is consumed through a Package Config file (OpenCL-CLHPP), this property
  # no longer holds unevaluated generator expressions.
  string(REGEX MATCHALL
    [[\$<BUILD_INTERFACE:(.*)>;]]
    OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES
    "${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}")
  set(OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_MATCH_1}")
endif()
# End of workaround

add_custom_command(
    OUTPUT stripped/cl.h
    COMMAND ${CMAKE_COMMAND} -E make_directory stripped
    COMMAND ${CMAKE_COMMAND} -E make_directory mocks
    COMMAND ${CMAKE_COMMAND} -D INPUT="${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl.h" -D OUTPUT="stripped/cl.h" -P ${CMAKE_CURRENT_SOURCE_DIR}/strip_defines.cmake
    COMMENT "Stripping defines from cl.h"
    DEPENDS ${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl.h strip_defines.cmake)

add_custom_target(
    strip_cl_defines ALL
    DEPENDS stripped/cl.h
    SOURCES strip_defines.cmake)

add_custom_command(
    OUTPUT mocks/Mockcl.c mocks/Mockcl.h
    COMMAND ${RUBY_EXECUTABLE} ${CMOCK_DIR}/lib/cmock.rb -o${CMAKE_CURRENT_SOURCE_DIR}/cmock.yml stripped/cl.h
    COMMENT "Generating mocks"
    DEPENDS stripped/cl.h cmock.yml)

add_custom_target(
    mock_cl_header ALL
    DEPENDS mocks/Mockcl.c mocks/Mockcl.h
    SOURCES cmock.yml)

add_dependencies(mock_cl_header strip_cl_defines)

add_custom_command(
    OUTPUT test_openclhpp_Runner.c
    COMMAND ${RUBY_EXECUTABLE} ${UNITY_DIR}/auto/generate_test_runner.rb test_openclhpp.cpp cmock.yml ${CMAKE_CURRENT_BINARY_DIR}/test_openclhpp_Runner.c
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Generating test runner"
    DEPENDS test_openclhpp.cpp cmock.yml)

add_custom_target(
    openclhpp_runner ALL
    DEPENDS test_openclhpp_Runner.c
    SOURCES test_openclhpp.cpp)

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_ID MATCHES "(Apple)?Clang")
    add_compile_options(-Wno-deprecated-declarations)
endif()

add_definitions(-DCL_TARGET_OPENCL_VERSION=300)
add_definitions(-DCL_EXPERIMENTAL)

add_definitions(-DUNITY_SUPPORT_64)
if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
    add_definitions(-DUNITY_POINTER_WIDTH=64)
    add_definitions("-DCMOCK_MEM_PTR_AS_INT=unsigned long long")
    add_definitions(-DCMOCK_MEM_ALIGN=3)
endif()
if( CMAKE_SIZEOF_LONG EQUAL 8 )
    add_definitions(-DUNITY_LONG_WIDTH=64)
endif()

set(TEST_HEADERS
    ${PROJECT_SOURCE_DIR}/include/CL/opencl.hpp
    mocks/Mockcl.h)

set(TEST_SOURCES
    ${CMAKE_CURRENT_BINARY_DIR}/test_openclhpp_Runner.c
    test_openclhpp.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/mocks/Mockcl.c
    ${CMOCK_DIR}/src/cmock.c
    ${UNITY_DIR}/src/unity.c)

# TODO enable testing for OpenCL 1.0 and 1.1
foreach(VERSION 120 200 210 220 300)
  foreach(OPTION "" CL_HPP_ENABLE_EXCEPTIONS CL_HPP_ENABLE_SIZE_T_COMPATIBILITY CL_HPP_ENABLE_PROGRAM_CONSTRUCTION_FROM_ARRAY_COMPATIBILITY CL_HPP_CL_1_2_DEFAULT_BUILD CL_HPP_USE_CL_DEVICE_FISSION CL_HPP_USE_CL_IMAGE2D_FROM_BUFFER_KHR CL_HPP_USE_CL_SUB_GROUPS_KHR CL_HPP_USE_IL_KHR)
    if(OPTION STREQUAL "")
      # The empty string means we're not setting any special option.
      set(UNDERSCORE_OPTION "${OPTION}")
      set(DEFINE_OPTION "")
    else()
      set(UNDERSCORE_OPTION "_${OPTION}")
      set(DEFINE_OPTION "-D${OPTION}")
    endif()

    set(TEST_EXE test_openclhpp_${VERSION}${UNDERSCORE_OPTION})
    add_executable(${TEST_EXE} ${TEST_SOURCES}) #${TEST_HEADERS})
    target_link_libraries(${TEST_EXE}
      PRIVATE
        OpenCL::HeadersCpp
        OpenCL::Headers
        Threads::Threads
    )
    target_include_directories(${TEST_EXE}
      PRIVATE
        ${CMAKE_CURRENT_BINARY_DIR}/mocks

        ${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL
        #${OPENCL_HEADERS_INCLUDE_DIR_GENEXPR}/CL

        ${UNITY_DIR}/src
        ${CMOCK_DIR}/src
    )
    target_compile_definitions(${TEST_EXE}
        PUBLIC -DCL_HPP_TARGET_OPENCL_VERSION=${VERSION} ${DEFINE_OPTION}
    )
    add_dependencies(${TEST_EXE}
        strip_cl_defines
        mock_cl_header
        openclhpp_runner
    )
    add_test(NAME ${TEST_EXE} COMMAND ${TEST_EXE})
  endforeach(OPTION)
endforeach(VERSION)

=== examples/make_example/Makefile ===
CC ?= gcc
BUILD_DIR ?= ./build
SRC_DIR ?= ./src
TEST_DIR ?= ./test
TEST_BUILD_DIR ?= ${BUILD_DIR}/test
TEST_MAKEFILE = ${TEST_BUILD_DIR}/MakefileTestSupport
OBJ ?= ${BUILD_DIR}/obj
OBJ_DIR = ${OBJ}

default: all

all: setup test ${BUILD_DIR}/main run

setup:
	mkdir -p ${BUILD_DIR}
	mkdir -p ${OBJ}
	ruby ../../scripts/create_makefile.rb --silent

clean:
	rm -rf ${BUILD_DIR}

${BUILD_DIR}/main: ${SRC_DIR}/main.c ${SRC_DIR}/foo.c
	${CC} $< -o $@

run:
	./build/main || true

test: setup

-include ${TEST_MAKEFILE}

=== tests/pkgconfig/bare/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(PkgConfigTest
  LANGUAGES CXX
)

find_package(OpenCLHeaders
  REQUIRED
  CONFIG
)
find_package(OpenCLICDLoader
  REQUIRED
  CONFIG
)
find_package(OpenCLHeadersCpp
  REQUIRED
  CONFIG
)

add_executable(${PROJECT_NAME}
  ../pkgconfig.cpp
)

target_link_libraries(${PROJECT_NAME}
  PRIVATE
    OpenCL::HeadersCpp
    OpenCL::Headers
    OpenCL::OpenCL
)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    CL_HPP_ENABLE_EXCEPTIONS
    CL_HPP_TARGET_OPENCL_VERSION=300
)

include(CTest)

add_test(
  NAME ${PROJECT_NAME}
  COMMAND ${PROJECT_NAME}
)

=== debian/changelog ===
khronos-opencl-clhpp (3.0~2023.02.06-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Mon, 13 Feb 2023 14:35:09 +0100

=== debian/control ===
Source: khronos-opencl-clhpp
Section: libdevel
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Vincent Danjean <vdanjean@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
               opencl-c-headers (>= 3.0~2021.04.29),
               cmake,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 ocl-icd-opencl-dev <!nocheck>,
 python-is-python3 <!nocheck>,
 ruby <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/KhronosGroup/OpenCL-CLHPP
Vcs-Browser: https://salsa.debian.org/opencl-team/khronos-opencl-clhpp
Vcs-Git: https://salsa.debian.org/opencl-team/khronos-opencl-clhpp.git

Package: opencl-clhpp-headers
Architecture: all
Multi-Arch: foreign
Depends: opencl-c-headers (>= 3.0~2021.04.29), ${misc:Depends}
Suggests: opencl-clhpp-headers-doc
Breaks: opencl-headers (<< 2.1)
Replaces: opencl-headers (<< 2.1)
Description: C++ headers for OpenCL development
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package provides the C++ development header files for the OpenCL API
 as published by The Khronos Group Inc. The corresponding specification and
 documentation can be found on the Khronos website.

Package: opencl-clhpp-headers-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Description: documentation for C++ OpenCL headers
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package provides the documentation of the C++ development header files
 for the OpenCL API as published by The Khronos Group Inc.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DOPENCL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		-DCMOCK_DIR=$(CURDIR)/cmock \
		-DUNITY_DIR=$(CURDIR)/unity \
		$(if $(filter nocheck,$(DEB_BUILD_PROFILES)),-DBUILD_EXAMPLES=OFF) \
		$(if $(filter nocheck,$(DEB_BUILD_PROFILES)),-DBUILD_TESTS=OFF) \

override_dh_auto_build:
	dh_auto_build -- all docs

execute_after_dh_auto_test:
	$(MAKE) -C debian/t

execute_after_dh_auto_clean:
	$(MAKE) -C debian/t clean

ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
execute_before_dh_installdeb:
	hardlink -v -t debian/opencl-clhpp-headers-doc/usr/share/doc/opencl-clhpp-headers
endif


ifneq (,$(wildcard .git))
khronos:
	git remote show $@ >/dev/null 2>&1 || git remote add $@ $(shell sed -rn 's/Repository: //p' debian/upstream/metadata)
	git fetch $@ --prune

tarball: COMMIT ?= khronos/master
tarball: COMMIT_TIME = $(shell git log --format=format:%ct -1 $(COMMIT))
tarball: COMMIT_DESCRIBE = $(patsubst v%,%,$(shell git describe --long --tags $(COMMIT)))
tarball: COMMIT_VERSION = $(firstword $(subst -, ,$(COMMIT_DESCRIBE)))
tarball: PREFIX = OpenCL-CLHPP-$(COMMIT_VERSION)+git$(patsubst $(COMMIT_VERSION)-%,%,$(COMMIT_DESCRIBE))
tarball:
	test -n "$(COMMIT)"
	git archive --prefix $(PREFIX)/ $(COMMIT) | xz > $(PREFIX).tar.xz
	touch -d @$(COMMIT_TIME) $(PREFIX).tar.xz
endif

=== debian/tests/control ===
Tests: compile-headers
Depends:
 opencl-clhpp-headers,
 g++,
Restrictions:
 superficial,
 allow-stderr,

Tests: upstream-testsuite
Depends:
 opencl-clhpp-headers,
 cmake,
 dpkg-dev,
 g++,
 ocl-icd-opencl-dev,
 python-is-python3,
 ruby,

## khronos-opencl-clhpp 3.0~2023.04.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -73,6 +73,9 @@
   EXPORT OpenCLHeadersCppTargets
 )
 
+set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+include(JoinPaths)
+
 include(GNUInstallDirs)
 
 install(
@@ -127,3 +130,11 @@
 if(CLHPP_BUILD_TESTS)
   add_subdirectory(tests)
 endif(CLHPP_BUILD_TESTS)
+
+join_paths(OPENCLHPP_INCLUDEDIR_PC "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
+
+configure_file(OpenCL-CLHPP.pc.in OpenCL-CLHPP.pc @ONLY)
+set(pkg_config_location ${CMAKE_INSTALL_DATADIR}/pkgconfig)
+install(
+  FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenCL-CLHPP.pc
+  DESTINATION ${pkg_config_location})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -40,27 +40,31 @@
 # End of workaround
 
 add_custom_command(
-    OUTPUT stripped/cl.h
+    OUTPUT stripped/cl.h stripped/cl_ext.h
     COMMAND ${CMAKE_COMMAND} -E make_directory stripped
     COMMAND ${CMAKE_COMMAND} -E make_directory mocks
     COMMAND ${CMAKE_COMMAND} -D INPUT="${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl.h" -D OUTPUT="stripped/cl.h" -P ${CMAKE_CURRENT_SOURCE_DIR}/strip_defines.cmake
-    COMMENT "Stripping defines from cl.h"
+    COMMAND ${CMAKE_COMMAND} -D INPUT="${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl_ext.h" -D OUTPUT="stripped/cl_ext.h" -P ${CMAKE_CURRENT_SOURCE_DIR}/strip_defines.cmake
+    COMMENT "Stripping defines from cl.h and cl_ext.h"
     DEPENDS ${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl.h strip_defines.cmake)
 
 add_custom_target(
     strip_cl_defines ALL
     DEPENDS stripped/cl.h
+    DEPENDS stripped/cl_ext.h
     SOURCES strip_defines.cmake)
 
 add_custom_command(
-    OUTPUT mocks/Mockcl.c mocks/Mockcl.h
+    OUTPUT mocks/Mockcl.c mocks/Mockcl.h mocks/Mockcl_ext.c mocks/Mockcl_ext.h
     COMMAND ${RUBY_EXECUTABLE} ${CMOCK_DIR}/lib/cmock.rb -o${CMAKE_CURRENT_SOURCE_DIR}/cmock.yml stripped/cl.h
+    COMMAND ${RUBY_EXECUTABLE} ${CMOCK_DIR}/lib/cmock.rb -o${CMAKE_CURRENT_SOURCE_DIR}/cmock.yml stripped/cl_ext.h
     COMMENT "Generating mocks"
-    DEPENDS stripped/cl.h cmock.yml)
+    DEPENDS stripped/cl.h stripped/cl_ext.h cmock.yml)
 
 add_custom_target(
     mock_cl_header ALL
     DEPENDS mocks/Mockcl.c mocks/Mockcl.h
+    DEPENDS mocks/Mockcl_ext.c mocks/Mockcl_ext.h
     SOURCES cmock.yml)
 
 add_dependencies(mock_cl_header strip_cl_defines)
@@ -79,6 +83,8 @@
 
 if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_ID MATCHES "(Apple)?Clang")
     add_compile_options(-Wno-deprecated-declarations)
+elseif(MSVC)
+    add_compile_options(/wd4996)
 endif()
 
 add_definitions(-DCL_TARGET_OPENCL_VERSION=300)
@@ -96,18 +102,20 @@
 
 set(TEST_HEADERS
     ${PROJECT_SOURCE_DIR}/include/CL/opencl.hpp
-    mocks/Mockcl.h)
+    mocks/Mockcl.h
+    mocks/Mockcl_ext.h)
 
 set(TEST_SOURCES
     ${CMAKE_CURRENT_BINARY_DIR}/test_openclhpp_Runner.c
     test_openclhpp.cpp
     ${CMAKE_CURRENT_BINARY_DIR}/mocks/Mockcl.c
+    ${CMAKE_CURRENT_BINARY_DIR}/mocks/Mockcl_ext.c
     ${CMOCK_DIR}/src/cmock.c
     ${UNITY_DIR}/src/unity.c)
 
 # TODO enable testing for OpenCL 1.0 and 1.1
 foreach(VERSION 120 200 210 220 300)
-  foreach(OPTION "" CL_HPP_ENABLE_EXCEPTIONS CL_HPP_ENABLE_SIZE_T_COMPATIBILITY CL_HPP_ENABLE_PROGRAM_CONSTRUCTION_FROM_ARRAY_COMPATIBILITY CL_HPP_CL_1_2_DEFAULT_BUILD CL_HPP_USE_CL_DEVICE_FISSION CL_HPP_USE_CL_IMAGE2D_FROM_BUFFER_KHR CL_HPP_USE_CL_SUB_GROUPS_KHR CL_HPP_USE_IL_KHR)
+  foreach(OPTION "" CL_HPP_ENABLE_EXCEPTIONS CL_HPP_ENABLE_SIZE_T_COMPATIBILITY CL_HPP_ENABLE_PROGRAM_CONSTRUCTION_FROM_ARRAY_COMPATIBILITY CL_HPP_CL_1_2_DEFAULT_BUILD CL_HPP_USE_CL_SUB_GROUPS_KHR CL_HPP_USE_IL_KHR)
     if(OPTION STREQUAL "")
       # The empty string means we're not setting any special option.
       set(UNDERSCORE_OPTION "${OPTION}")

=== debian/changelog ===
khronos-opencl-clhpp (3.0~2023.04.17-2ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 Aug 2023 15:48:56 +0200

khronos-opencl-clhpp (3.0~2023.04.17-2) unstable; urgency=medium

  * Ignore stderr output (new CMake deprecation warnings) in autopkgtest.
    (Closes: #1040730)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 04 Aug 2023 14:30:56 +0200

khronos-opencl-clhpp (3.0~2023.04.17-1.1ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 03 Aug 2023 11:21:06 +0200

khronos-opencl-clhpp (3.0~2023.04.17-1ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 17 Jul 2023 17:29:14 -0700

khronos-opencl-clhpp (3.0~2023.04.17-1) unstable; urgency=medium

  * New upstream release.
  * Stop testing OpenCL 1.0, 1.1.
  * Ship the pkgconfig file.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 20 Jun 2023 02:31:24 +0200

khronos-opencl-clhpp (3.0~2023.02.06-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 02 May 2023 09:43:02 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
                cmake,
  doxygen <!nodoc>,
  graphviz <!nodoc>,
- ocl-icd-opencl-dev <!nocheck>,
  python-is-python3 <!nocheck>,
  ruby <!nocheck>,
 Rules-Requires-Root: no

=== debian/tests/control ===
--- 
+++ 
@@ -15,3 +15,5 @@
  ocl-icd-opencl-dev,
  python-is-python3,
  ruby,
+Restrictions:
+ allow-stderr,

## khronos-opencl-clhpp 3.0~2023.12.14

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -40,31 +40,35 @@
 # End of workaround
 
 add_custom_command(
-    OUTPUT stripped/cl.h stripped/cl_ext.h
+    OUTPUT stripped/cl.h stripped/cl_ext.h stripped/cl_gl.h
     COMMAND ${CMAKE_COMMAND} -E make_directory stripped
     COMMAND ${CMAKE_COMMAND} -E make_directory mocks
     COMMAND ${CMAKE_COMMAND} -D INPUT="${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl.h" -D OUTPUT="stripped/cl.h" -P ${CMAKE_CURRENT_SOURCE_DIR}/strip_defines.cmake
     COMMAND ${CMAKE_COMMAND} -D INPUT="${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl_ext.h" -D OUTPUT="stripped/cl_ext.h" -P ${CMAKE_CURRENT_SOURCE_DIR}/strip_defines.cmake
-    COMMENT "Stripping defines from cl.h and cl_ext.h"
+    COMMAND ${CMAKE_COMMAND} -D INPUT="${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl_gl.h" -D OUTPUT="stripped/cl_gl.h" -P ${CMAKE_CURRENT_SOURCE_DIR}/strip_defines.cmake
+    COMMENT "Stripping defines from cl.h, cl_ext.h and cl_gl.h"
     DEPENDS ${OPENCL_HEADERS_INTERFACE_INCLUDE_DIRECTORIES}/CL/cl.h strip_defines.cmake)
 
 add_custom_target(
     strip_cl_defines ALL
     DEPENDS stripped/cl.h
     DEPENDS stripped/cl_ext.h
+    DEPENDS stripped/cl_gl.h
     SOURCES strip_defines.cmake)
 
 add_custom_command(
-    OUTPUT mocks/Mockcl.c mocks/Mockcl.h mocks/Mockcl_ext.c mocks/Mockcl_ext.h
+    OUTPUT mocks/Mockcl.c mocks/Mockcl.h mocks/Mockcl_ext.c mocks/Mockcl_ext.h mocks/Mockcl_gl.c mocks/Mockcl_gl.h
     COMMAND ${RUBY_EXECUTABLE} ${CMOCK_DIR}/lib/cmock.rb -o${CMAKE_CURRENT_SOURCE_DIR}/cmock.yml stripped/cl.h
     COMMAND ${RUBY_EXECUTABLE} ${CMOCK_DIR}/lib/cmock.rb -o${CMAKE_CURRENT_SOURCE_DIR}/cmock.yml stripped/cl_ext.h
+    COMMAND ${RUBY_EXECUTABLE} ${CMOCK_DIR}/lib/cmock.rb -o${CMAKE_CURRENT_SOURCE_DIR}/cmock.yml stripped/cl_gl.h
     COMMENT "Generating mocks"
-    DEPENDS stripped/cl.h stripped/cl_ext.h cmock.yml)
+    DEPENDS stripped/cl.h stripped/cl_ext.h stripped/cl_gl.h cmock.yml)
 
 add_custom_target(
     mock_cl_header ALL
     DEPENDS mocks/Mockcl.c mocks/Mockcl.h
     DEPENDS mocks/Mockcl_ext.c mocks/Mockcl_ext.h
+    DEPENDS mocks/Mockcl_gl.c mocks/Mockcl_gl.h
     SOURCES cmock.yml)
 
 add_dependencies(mock_cl_header strip_cl_defines)
@@ -103,13 +107,15 @@
 set(TEST_HEADERS
     ${PROJECT_SOURCE_DIR}/include/CL/opencl.hpp
     mocks/Mockcl.h
-    mocks/Mockcl_ext.h)
+    mocks/Mockcl_ext.h
+    mocks/Mockcl_gl.h)
 
 set(TEST_SOURCES
     ${CMAKE_CURRENT_BINARY_DIR}/test_openclhpp_Runner.c
     test_openclhpp.cpp
     ${CMAKE_CURRENT_BINARY_DIR}/mocks/Mockcl.c
     ${CMAKE_CURRENT_BINARY_DIR}/mocks/Mockcl_ext.c
+    ${CMAKE_CURRENT_BINARY_DIR}/mocks/Mockcl_gl.c
     ${CMOCK_DIR}/src/cmock.c
     ${UNITY_DIR}/src/unity.c)
 
@@ -154,3 +160,26 @@
     add_test(NAME ${TEST_EXE} COMMAND ${TEST_EXE})
   endforeach(OPTION)
 endforeach(VERSION)
+
+if(NOT TARGET OpenCL::openCL)
+  find_package(OpenCLICDLoader)
+endif()
+if(TARGET OpenCL::OpenCL)
+  # TODO enable testing for OpenCL 1.0 and 1.1
+  foreach(MINVERSION 120 200 210 220 300)
+    foreach(TARGETVERSION 120 200 210 220 300)
+      if(NOT (${MINVERSION} GREATER ${TARGETVERSION}))
+        set(TEST_EXE test_openclhpp_version_min_${MINVERSION}_target_${TARGETVERSION})
+        add_executable(${TEST_EXE} test_versions.cpp)
+        target_compile_definitions(${TEST_EXE} PUBLIC
+          CL_HPP_MINIMUM_OPENCL_VERSION=${MINVERSION}
+          CL_HPP_TARGET_OPENCL_VERSION=${TARGETVERSION})
+        target_link_libraries(${TEST_EXE} PRIVATE
+          OpenCL::HeadersCpp
+          OpenCL::Headers
+          OpenCL::OpenCL)
+        add_test(NAME ${TEST_EXE} COMMAND ${TEST_EXE})
+      endif()
+    endforeach()
+  endforeach()
+endif()

=== tests/pkgconfig/sdk/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(PkgConfigTest
  LANGUAGES CXX
)

find_package(OpenCL
  REQUIRED
  CONFIG
  COMPONENTS
    HeadersCpp
    Headers
    OpenCL
)

add_executable(${PROJECT_NAME}
  ../pkgconfig.cpp
)

target_link_libraries(${PROJECT_NAME}
  PRIVATE
    OpenCL::HeadersCpp
    OpenCL::Headers
    OpenCL::OpenCL
)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    CL_HPP_ENABLE_EXCEPTIONS
    CL_HPP_TARGET_OPENCL_VERSION=300
)

include(CTest)

add_test(
  NAME ${PROJECT_NAME}
  COMMAND ${PROJECT_NAME}
)

=== debian/changelog ===
khronos-opencl-clhpp (3.0~2023.12.14-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 20 Jan 2024 16:43:56 +0100

khronos-opencl-clhpp (3.0~2023.12.14-1) unstable; urgency=medium

  * New upstream release.
  * Use separately packaged CMock/unity.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 19 Jan 2024 14:11:04 +0100

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,7 @@
                cmake,
  doxygen <!nodoc>,
  graphviz <!nodoc>,
- python-is-python3 <!nocheck>,
- ruby <!nocheck>,
+ cmock <!nocheck>,
 Rules-Requires-Root: no
 Standards-Version: 4.6.2
 Homepage: https://github.com/KhronosGroup/OpenCL-CLHPP

## khronos-opencl-clhpp 3.0~2024.05.08

=== debian/changelog ===
khronos-opencl-clhpp (3.0~2024.05.08-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.
    - Don't build the examples; this is an arch: independent package so testing
      them on only the build arch doesn't make sense, these should be moved to
      autopkgtests.  For now, just drop the examples and the build-dependency
      on ocl-icd-opencl-dev to break a build loop.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Jun 2024 08:28:03 +0200

khronos-opencl-clhpp (3.0~2024.05.08-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Fri, 14 Jun 2024 01:14:47 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  graphviz <!nodoc>,
  cmock <!nocheck>,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/KhronosGroup/OpenCL-CLHPP
 Vcs-Browser: https://salsa.debian.org/opencl-team/khronos-opencl-clhpp
 Vcs-Git: https://salsa.debian.org/opencl-team/khronos-opencl-clhpp.git

## khronos-opencl-clhpp 3.0~2024.10.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.16)
 
 project(OpenCLHeadersCpp
   VERSION 3.0
@@ -73,10 +73,11 @@
   EXPORT OpenCLHeadersCppTargets
 )
 
+include(GNUInstallDirs)
+
 set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 include(JoinPaths)
-
-include(GNUInstallDirs)
+include(Package)
 
 install(
   DIRECTORY include/CL
@@ -116,7 +117,7 @@
   DESTINATION ${config_package_location}
 )
 
-set(UNITY_DIR ${PROJECT_SOURCE_DIR}/external/Unity CACHE PATH "Unity dir")
+set(UNITY_DIR ${PROJECT_SOURCE_DIR}/external/CMock/vendor/unity CACHE PATH "Unity dir")
 set(CMOCK_DIR ${PROJECT_SOURCE_DIR}/external/CMock CACHE PATH "CMock dir")
 
 if(BUILD_DOCS)
@@ -130,11 +131,3 @@
 if(CLHPP_BUILD_TESTS)
   add_subdirectory(tests)
 endif(CLHPP_BUILD_TESTS)
-
-join_paths(OPENCLHPP_INCLUDEDIR_PC "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
-
-configure_file(OpenCL-CLHPP.pc.in OpenCL-CLHPP.pc @ONLY)
-set(pkg_config_location ${CMAKE_INSTALL_DATADIR}/pkgconfig)
-install(
-  FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenCL-CLHPP.pc
-  DESTINATION ${pkg_config_location})

=== debian/changelog ===
khronos-opencl-clhpp (3.0~2024.10.24-2) unstable; urgency=medium

  * Bump opencl-c-headers dependency due to updated extensions.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 27 Nov 2024 12:40:30 +0100

khronos-opencl-clhpp (3.0~2024.10.24-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 21 Nov 2024 21:55:15 +0100

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,12 @@
 Uploaders: Vincent Danjean <vdanjean@debian.org>,
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends: debhelper-compat (= 13),
-               opencl-c-headers (>= 3.0~2021.04.29),
+ opencl-c-headers (>= 3.0~2024.10.24),
                cmake,
  doxygen <!nodoc>,
  graphviz <!nodoc>,
  cmock <!nocheck>,
+ ocl-icd-opencl-dev <!nocheck>,
 Rules-Requires-Root: no
 Standards-Version: 4.7.0
 Homepage: https://github.com/KhronosGroup/OpenCL-CLHPP
@@ -19,7 +20,9 @@
 Package: opencl-clhpp-headers
 Architecture: all
 Multi-Arch: foreign
-Depends: opencl-c-headers (>= 3.0~2021.04.29), ${misc:Depends}
+Depends:
+ opencl-c-headers (>= 3.0~2024.10.24),
+ ${misc:Depends}
 Suggests: opencl-clhpp-headers-doc
 Breaks: opencl-headers (<< 2.1)
 Replaces: opencl-headers (<< 2.1)

=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,8 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DOPENCL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
-		-DCMOCK_DIR=$(CURDIR)/cmock \
-		-DUNITY_DIR=$(CURDIR)/unity \
+		-DCMOCK_DIR=/usr/share/cmock \
+		-DUNITY_DIR=/usr/share/cmock/vendor/unity \
 		$(if $(filter nocheck,$(DEB_BUILD_PROFILES)),-DBUILD_EXAMPLES=OFF) \
 		$(if $(filter nocheck,$(DEB_BUILD_PROFILES)),-DBUILD_TESTS=OFF) \

## khronos-opencl-clhpp 3.0~2025.07.22

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -93,6 +93,7 @@
 
 add_definitions(-DCL_TARGET_OPENCL_VERSION=300)
 add_definitions(-DCL_EXPERIMENTAL)
+add_definitions(-DCL_ENABLE_BETA_EXTENSIONS)
 
 add_definitions(-DUNITY_SUPPORT_64)
 if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
@@ -152,6 +153,14 @@
     target_compile_definitions(${TEST_EXE}
         PUBLIC -DCL_HPP_TARGET_OPENCL_VERSION=${VERSION} ${DEFINE_OPTION}
     )
+    if(MSVC AND (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
+      # This is quite hacky, but the definition noreturn in Clang's
+      # stdnoreturn.h is not compatible with stdlib.h in the Windows SDK.
+      # This could normally be resolved by changing the order of include
+      # files, but not possible in this project due to the generated nature
+      # of the source files.
+      target_compile_definitions(${TEST_EXE} PRIVATE __STDNORETURN_H UNITY_NORETURN=_Noreturn)
+    endif()
     add_dependencies(${TEST_EXE}
         strip_cl_defines
         mock_cl_header

=== examples/src/CMakeLists.txt ===
file(GLOB OPENCL_LIBS_IN_LIB_DIR "${OPENCL_CLHPP_LOADER_DIR}/*OpenCL*")
if(NOT "${OPENCL_LIBS_IN_LIB_DIR}" STREQUAL "")
  if(NOT TARGET OpenCL)
    message(STATUS "Adding flags to CLHPP examples as per OPENCL_LIB_DIR")
    link_directories("${OPENCL_LIB_DIR}")
  else()
    message(WARNING "User-provided OpenCL library found in ${OPENCL_LIB_DIR}. Cannot use it because the target \"OpenCL\" already exists in the build.")
  endif()
else()
  if(NOT TARGET OpenCL::OpenCL)
    find_package(OpenCLICDLoader REQUIRED)
  endif()
endif()

foreach(EXAMPLE IN ITEMS
  trivial
  trivialSizeTCompat
  headerexample
)
  add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
  target_link_libraries(${EXAMPLE}
    PRIVATE
      OpenCL::HeadersCpp
      OpenCL::Headers
      Threads::Threads
  )
  if(NOT "${OPENCL_LIBS_IN_LIB_DIR}" STREQUAL "")
    target_link_libraries(${EXAMPLE} PRIVATE OpenCL)
  else()
  target_link_libraries(${EXAMPLE} PRIVATE OpenCL::OpenCL)
  endif()
endforeach()

=== tests/pkgconfig/bare/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.16)
 
 project(PkgConfigTest
   LANGUAGES CXX

=== tests/pkgconfig/sdk/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.16)
 
 project(PkgConfigTest
   LANGUAGES CXX

=== debian/changelog ===
khronos-opencl-clhpp (3.0~2025.07.22-1ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.
    - Don't build the examples; this is an arch: independent package so testing
      them on only the build arch doesn't make sense, these should be moved to
      autopkgtests.  For now, just drop the examples and the build-dependency
      on ocl-icd-opencl-dev to break a build loop.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 13 Aug 2025 18:48:29 +0200

khronos-opencl-clhpp (3.0~2025.07.22-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 13:48:28 +0200

khronos-opencl-clhpp (3.0~2024.10.24-2ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.
    - Don't build the examples; this is an arch: independent package so testing
      them on only the build arch doesn't make sense, these should be moved to
      autopkgtests.  For now, just drop the examples and the build-dependency
      on ocl-icd-opencl-dev to break a build loop.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Nov 2024 10:02:41 +0100

khronos-opencl-clhpp (3.0~2024.10.24-1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build-depend on ocl-icd-opencl-dev, we can't use 'nocheck' build
      profile for this in Launchpad.
    - Don't build the examples; this is an arch: independent package so testing
      them on only the build arch doesn't make sense, these should be moved to
      autopkgtests.  For now, just drop the examples and the build-dependency
      on ocl-icd-opencl-dev to break a build loop.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 22 Nov 2024 10:36:04 +0100

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,8 @@
  doxygen <!nodoc>,
  graphviz <!nodoc>,
  cmock <!nocheck>,
- ocl-icd-opencl-dev <!nocheck>,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/KhronosGroup/OpenCL-CLHPP
 Vcs-Browser: https://salsa.debian.org/opencl-team/khronos-opencl-clhpp
 Vcs-Git: https://salsa.debian.org/opencl-team/khronos-opencl-clhpp.git

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+		-DBUILD_EXAMPLES=OFF \
 		-DOPENCL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		-DCMOCK_DIR=/usr/share/cmock \
 		-DUNITY_DIR=/usr/share/cmock/vendor/unity \

=== debian/tests/control ===
--- 
+++ 
@@ -10,10 +10,9 @@
 Depends:
  opencl-clhpp-headers,
  cmake,
+ cmock,
  dpkg-dev,
  g++,
  ocl-icd-opencl-dev,
- python-is-python3,
- ruby,
 Restrictions:
  allow-stderr,

=== debian/watch ===
version=4
opts="dversionmangle=s/^\d[\d.]*~//, filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/KhronosGroup/OpenCL-CLHPP/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
